<?php

/**
 * @file
 * Provide views data and handlers for field_tracker.module
 */

/**
 * Implementents hook_views_handlers().
 */
function track_field_changes_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'track_field_changes') . '/views',
    ),
    'handlers' => array(
      'track_field_changes_handler_field_field_info' => array(
        'parent' => 'views_handler_field',
      ),
      'track_field_changes_handler_field_value_before' => array(
        'parent' => 'views_handler_field',
      ),
      'track_field_changes_handler_field_value_after' => array(
        'parent' => 'views_handler_field',
      ),
      'track_field_changes_handler_filter_field_info' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
    ),
  );
}


/**
 * Implementents hook_views_data().
 */
function track_field_changes_views_data() {
  $data = array();
  // Define the {domain} table.
  $data['track_field_changes_audit']['table']['group'] = t('Field Tracker');
  $data['track_field_changes_audit']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );

  $data['track_field_changes_audit']['field_name'] = array(
    'title' => t('Field Name'),
    'help' => t('The unique id key for the active domain.'),
    'field' => array(
      'handler' => 'track_field_changes_handler_field_field_info',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'track_field_changes_handler_filter_field_info',
    ),
  );

  $data['track_field_changes_audit']['timestamp'] = array(
    'title' => t('Creation Date'),
    'help' => t('Display the time the field was updated by a user.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
  );

  $data['track_field_changes_audit']['before_value_text'] = array(
    'title' => t('Value Before'),
    'help' => t('The unique id key for the active domain.'),
    'field' => array(
      'handler' => 'track_field_changes_handler_field_value_before',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['track_field_changes_audit']['after_value_text'] = array(
    'title' => t('Value After'),
    'help' => t('The unique id key for the active domain.'),
    'field' => array(
      'handler' => 'track_field_changes_handler_field_value_after',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['track_field_changes_audit']['uid'] = array(
    'title' => t('User'),
    'help' => t('The user that update the field.'),
    'field' => array(
      'handler' => 'views_handler_field_user',
      'click sortable' => TRUE,
    ),
    'relationship' => array(
      'base' => 'users',
      'handler' => 'views_handler_relationship',
      'label' => t('Field Tracker User'),
    ),
  );  

  return $data;
}
